---
title: Import SQL into your D1 Database
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[D1](https://developers.cloudflare.com/api/go/resources/d1)

[Database](https://developers.cloudflare.com/api/go/resources/d1/subresources/database)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Import SQL into your D1 Database

client.D1.Database.Import(ctx, databaseID, params) (\*[DatabaseImportResponse](<https://developers.cloudflare.com/api/go/resources/d1#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/d1/database/{database\_id}/import

Generate a temporary URL for uploading an SQL file to, then instruct the D1 to import it and poll it for status updates. Imports block the D1 for their duration.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### ParametersExpand Collapse

databaseID string

D1 database identifier (UUID).

[Link to this property](<#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%20default%20%3E%20(param)%20database_id%20%3E%20(schema)>)

<details>

<summary>

params DatabaseImportParams

</summary>

AccountID param.Field\[string]

Path param: Account identifier tag.

maxLength32

<a href="#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200%20%3E%20(param)%20account_id">Link to this property</a>

<details>

<summary>

Action param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/d1/subresources/database/methods/import#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200%20%3E%20(param)%20action%20%3E%20(schema)">DatabaseImportParamsInitAction</a>]

Body param: Indicates you have a new SQL file to upload.

</summary>

const DatabaseImportParamsInitActionInit <a href="https://developers.cloudflare.com/api/go/resources/d1/subresources/database/methods/import#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200%20%3E%20(param)%20action%20%3E%20(schema)">DatabaseImportParamsInitAction</a> = "init"

<a href="#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200%20%3E%20(param)%20action%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

</details>

<a href="#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200%20%3E%20(param)%20action">Link to this property</a>

Etag param.Field\[string]

Body param: Required when action is ‘init’ or ‘ingest’. An md5 hash of the file you’re uploading. Used to check if it already exists, and validate its contents before ingesting.

<a href="#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200%20%3E%20(param)%20etag">Link to this property</a>

</details>

[Link to this property](<#(resource)%20d1.database%20%3E%20(method)%20import%20%3E%20(params)%200>)

##### ReturnsExpand Collapse

<details>

<summary>

type DatabaseImportResponse struct{…}

</summary>

AtBookmark stringOptional

The current time-travel bookmark for your D1, used to poll for updates. Will not change for the duration of the import. Only returned if an import process is currently running or recently finished.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20at_bookmark">Link to this property</a>

Error stringOptional

Only present when status = ‘error’. Contains the error message that prevented the import from succeeding.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20error">Link to this property</a>

Filename stringOptional

Derived from the database ID and etag, to use in avoiding repeated uploads. Only returned when for the ‘init’ action.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20filename">Link to this property</a>

Messages \[]stringOptional

Logs since the last time you polled

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20messages">Link to this property</a>

<details>

<summary>

Result DatabaseImportResponseResultOptional

Only present when status = ‘complete’

</summary>

FinalBookmark stringOptional

The time-travel bookmark if you need restore your D1 to directly after the import succeeded.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20final_bookmark">Link to this property</a>

<details>

<summary>

Meta DatabaseImportResponseResultMetaOptional

</summary>

ChangedDB boolOptional

Denotes if the database has been altered in some way, like deleting rows.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20changed_db">Link to this property</a>

Changes float64Optional

Rough indication of how many rows were modified by the query, as provided by SQLite’s <code>sqlite3_total_changes()</code>.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20changes">Link to this property</a>

Duration float64Optional

The duration of the SQL query execution inside the database. Does not include any network communication.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20duration">Link to this property</a>

LastRowID float64Optional

The row ID of the last inserted row in a table with an <code>INTEGER PRIMARY KEY</code> as provided by SQLite. Tables created with <code>WITHOUT ROWID</code> do not populate this.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20last_row_id">Link to this property</a>

RowsRead float64Optional

Number of rows read during the SQL query execution, including indices (not all rows are necessarily returned).

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20rows_read">Link to this property</a>

RowsWritten float64Optional

Number of rows written during the SQL query execution, including indices.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20rows_written">Link to this property</a>

ServedByColo stringOptional

The three letters airport code of the colo that handled the query.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_colo">Link to this property</a>

ServedByPrimary boolOptional

Denotes if the query has been handled by the database primary instance.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_primary">Link to this property</a>

<details>

<summary>

ServedByRegion DatabaseImportResponseResultMetaServedByRegionOptional

Region location hint of the database instance that handled the query.

</summary>

One of the following:

const DatabaseImportResponseResultMetaServedByRegionWnam DatabaseImportResponseResultMetaServedByRegion = "WNAM"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region%20%3E%20(member)%200">Link to this property</a>

const DatabaseImportResponseResultMetaServedByRegionEnam DatabaseImportResponseResultMetaServedByRegion = "ENAM"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region%20%3E%20(member)%201">Link to this property</a>

const DatabaseImportResponseResultMetaServedByRegionWeur DatabaseImportResponseResultMetaServedByRegion = "WEUR"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region%20%3E%20(member)%202">Link to this property</a>

const DatabaseImportResponseResultMetaServedByRegionEeur DatabaseImportResponseResultMetaServedByRegion = "EEUR"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region%20%3E%20(member)%203">Link to this property</a>

const DatabaseImportResponseResultMetaServedByRegionApac DatabaseImportResponseResultMetaServedByRegion = "APAC"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region%20%3E%20(member)%204">Link to this property</a>

const DatabaseImportResponseResultMetaServedByRegionOc DatabaseImportResponseResultMetaServedByRegion = "OC"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region%20%3E%20(member)%205">Link to this property</a>

</details>

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20served_by_region">Link to this property</a>

SizeAfter float64Optional

Size of the database after the query committed, in bytes.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20size_after">Link to this property</a>

<details>

<summary>

Timings DatabaseImportResponseResultMetaTimingsOptional

Various durations for the query.

</summary>

SqlDurationMs float64Optional

The duration of the SQL query execution inside the database. Does not include any network communication.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20timings%20%3E%20(property)%20sql_duration_ms">Link to this property</a>

</details>

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta%20%3E%20(property)%20timings">Link to this property</a>

</details>

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20meta">Link to this property</a>

NumQueries float64Optional

The total number of queries that were executed during the import.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result%20%3E%20(property)%20num_queries">Link to this property</a>

</details>

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20result">Link to this property</a>

<details>

<summary>

Status DatabaseImportResponseStatusOptional

</summary>

One of the following:

const DatabaseImportResponseStatusComplete DatabaseImportResponseStatus = "complete"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

const DatabaseImportResponseStatusError DatabaseImportResponseStatus = "error"

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20status">Link to this property</a>

Success boolOptional

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20success">Link to this property</a>

Type DatabaseImportResponseTypeOptional

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20type">Link to this property</a>

UploadURL stringOptional

The R2 presigned URL to use for uploading. Only returned when for the ‘init’ action.

<a href="#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)%20%3E%20(property)%20upload_url">Link to this property</a>

</details>

[Link to this property](<#(resource)%20d1.database%20%3E%20(model)%20DatabaseImportResponse%20%3E%20(schema)>)

### Import SQL into your D1 Database

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/d1"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.D1.Database.Import(
    context.TODO(),
    "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
    d1.DatabaseImportParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
      Body: d1.DatabaseImportParamsBodyInit{
        Action: cloudflare.F(d1.DatabaseImportParamsBodyInitActionInit),
        Etag: cloudflare.F("etag"),
      },
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.AtBookmark)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "at_bookmark": "at_bookmark",
    "error": "error",
    "filename": "filename",
    "messages": [
      "string"
    ],
    "result": {
      "final_bookmark": "final_bookmark",
      "meta": {
        "changed_db": true,
        "changes": 0,
        "duration": 0,
        "last_row_id": 0,
        "rows_read": 0,
        "rows_written": 0,
        "served_by_colo": "LHR",
        "served_by_primary": true,
        "served_by_region": "EEUR",
        "size_after": 0,
        "timings": {
          "sql_duration_ms": 0
        }
      },
      "num_queries": 0
    },
    "status": "complete",
    "success": true,
    "type": "import",
    "upload_url": "upload_url"
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "at_bookmark": "at_bookmark",
    "error": "error",
    "filename": "filename",
    "messages": [
      "string"
    ],
    "result": {
      "final_bookmark": "final_bookmark",
      "meta": {
        "changed_db": true,
        "changes": 0,
        "duration": 0,
        "last_row_id": 0,
        "rows_read": 0,
        "rows_written": 0,
        "served_by_colo": "LHR",
        "served_by_primary": true,
        "served_by_region": "EEUR",
        "size_after": 0,
        "timings": {
          "sql_duration_ms": 0
        }
      },
      "num_queries": 0
    },
    "status": "complete",
    "success": true,
    "type": "import",
    "upload_url": "upload_url"
  },
  "success": true
}
```